
// -------------------------------------------------------------------
// A. Veneziani - Programma ad oggetti simulante il lancio
//                di due dadi
//
//                Realizzato in classe (IV Inf) il 26/11/2013
//
//                Scritto in C++ Builder 6
// -------------------------------------------------------------------

#include <conio.h>
#include <iostream>
#include <stdlib.h>
using namespace std;

// classe Dado; rappresenta un singolo dado
class Dado
{
   int numero;    // stato interno -> numero estratto

   public:
   // comanda un nuovo lancio del dado...
   void lancio()
   {
      numero = random(6) + 1;
   }

   // legge il valore assunto dal dado nell' ultimo lancio
   int leggi()
   {
      return(numero);
   }

   Dado()
   {
      // fornisce casualita' alle seuqneze di numeri casuali
      randomize();
      // lo stato iniziale del dado si suppone a caso (tra i valori 1 e 6)
      numero = random(6) + 1;
   }
};

// classe derivata Dadi;
// composta da due dadi, ossia due elementi di tipo Dado
// ha metodi specifici, che utlizzano quelli della sua superclasse Dado
class Dadi: public Dado
{
   Dado d1,d2;   // genera due dadi

   public:
   // lancio del doppio dado --> equivale a due lanci singoli
   void lancia()
   {
      d1.lancio();
      d2.lancio();
   }

   // lettura del doppio dado -> si devono sommare i
   // valori risultanti dei due dadi
   int leggi()
   {
      int somma;

      // somma dei valori estratti su d1 e d2
      somma = d1.leggi() + d2.leggi();

      return(somma);
   }
 };

void main()
{
   Dadi d;         // l'oggetto d rappresenta un doppio dado
   int le, i;

   // ciclo che effettua 50 lanci di test 
   for(i = 0; i < 50; i++)
   {
      d.lancia();        // lancia il doppio dado
      le = d.leggi();         // legge i valori del doppio dado

      cout << "Il numero uscito dal lancio dei due dadi e':  " << le << endl;    // stampa a video
   }

   getch();        // evita l'uscita immediata dal programma
}

